/* Output from p2c, the Pascal-to-C translator */
/* From input file "reton.text" */


#include <p2c/p2c.h>


#ifndef GENERAL_2_H
#include <p2c/general_2.h>
#endif
/* p2c: reton.text, line 7: Warning: Could not find module GRAPHICS [271] */

/*#include "graphics.h"*/

/*homeless orphans*/

#ifndef MISC_H
#include <p2c/misc.h>
#endif

#ifndef WOLCOMPLIB_H
#include <wolcomp.h>
#endif

#ifndef WOLCOMPII_H
#include <wolcompii.h>
#endif


#define plotter         705


/******************************************/
/*********** main program ***********/

main(argc, argv)
int argc;
Char *argv[];
{  /*main program*/
  long i;   /*index of current row*/
  long j, k, x2, y2, x3, y3, x4, y4, x5, y5, nrows, ncols;

  char libfile[100];

  PASCAL_MAIN(argc, argv);
/*
  printf("lambda= [80,100,150] ? ");
  scanf("%ld%*[^\n]", &lambda);
  getchar();
*/
  lambda=100;

  printf("Nrows = ");
  scanf("%ld%*[^\n]", &nrows);
  getchar();
  printf("Ncols = ");
  scanf("%ld%*[^\n]", &ncols);
  getchar();
/*
  printf("library file? ");
  scanf("%s",libfile);
  getchar();
*/

  wolcomp_init(lambda);
/*
  load_library(libfile);
*/
  load_library("retonoff10.wolcif");

  define_cell("bot");
  hcompose();
  make_array("csrlmux", ncols);
  place("lrarray");
  endef();

  define_cell("top");
  hcompose();
  place("ltop");
  make_array("topsp", ncols);
  place("rtop");
  endef();

  define_cell("right");
  vcompose();
  make_array("rtpr", nrows);
  endef();

  define_cell("left");
  vcompose();
  place("csrlbuf");
  place("csrlbufc");      /* this is where clock comes in !!*/
  make_array("csrlbuf", nrows-2 );
  endef();

  define_cell("row");
  hcompose();
  make_array("pixel", ncols);
  endef();

  define_cell("core");
  vcompose();
  make_array("row", nrows);
  endef();

  define_cell("lcrt");
  nocompose();
  draw(cell("left"));
  x0 = x1;
  draw(cell("core"));
  x0 = x1;
  draw(cell("right"));
  x0 = 0;
  y0_ = y1_;
  draw(cell("top"));
  y0_ = y1_;
  endef();


/**********************************

  make clkdly by hand in ledit


  define_cell("clkdly");
  nocompose();
  draw(cell("llcor"));
  x0 = x1;
  draw(cell("endturn"));
  x0 = x1;
  draw(cell("csrlmod"));
  x0 = x1;
  draw(cell("csrlmod"));
  x0 = x1;
  draw(cell("csrlmod"));
  x0 = x1;
  draw(cell("csrlmodt"));
  x0 = x1;
  draw(cell("csrlmod"));
  x0 = x1;
  draw(cell("csrlmod"));
  x0 = x1;
  draw(cell("csrlmodr"));
  x0 = x1 - cell("llarray")->lx;
  y0_ = y1_;
  draw(cell("llarray"));
  x0 = 0;
  y4 = y1_;
  draw(cell("clkmid"));
  y0_ = y1_;
  drawx(cell("clkend"), 2L);
  x0 = x1;
  drawx(cell("endturn"), 6L);
  x0 = x1;
  drawx(cell("csrlmod"), 2L);
  x0 = x1;
  drawx(cell("csrlmod"), 2L);
  x0 = x1;
  drawx(cell("csrlmods"), 2L);
  x0 = x1;
  drawx(cell("csrlmodt"), 2L);
  x0 = x1;
  y0_ -= 72;
  drawx(cell("clksp"), 2L);
  x0 = 0;
  y0_ = y1_;
  draw(cell("jvcntr"));
  x4 = x1;
  endef();


**************************************/

  define_cell("framed");
  nocompose();
  place("clkdly");
  x0=x1;
  place("bot");            /* put bot to right of clkdly */
  y0_ = y1_;
  x0=x0-cell_width("left");
  place("lcrt");           /* put lcrt above bot nestled to left against clkdly*/
  x0 = 0;
  y0_ = y1_ - cell_height("vext");  /* attach vext to upper left */
  place("vext");
  endef();



/**********************************
  build the pads by hand in ledit


  define_cell("nepads");
  hcompose();
  place("gpad");
  place("rpad");
  place("pixref");
  endef();

  define_cell("wnpads");
  vcompose();
  place("vddpad");
  place("pdbiaspad");
  place("vsyncpad");
  place("scaninpad");
  endef();

  define_cell("wspads");
  vcompose();
  place("hblankpad");
  place("hsyncpad");
  place("clkpad");
  place("clkinvpad");
  place("clk1pad");
  place("vddpad");
  endef();

  define_cell("espads");
  vcompose();
  place("videosd1pad");
  place("vrefpad");
  place("sbiaspad");
  place("gndpad");
  endef();

  define_cell("sepads");
  hcompose();
  place("videovpad");
  place("videosd2pad");
  endef();

  define_cell("nwpads");
  hcompose();
  transform((long)R90);
  place("vblankpad");
  place("vdd1pad");
  place("gndpad");
  transform((long)R0);
  endef();
********************************************************/

  define_cell("chip");
  nocompose();
  x2 = cell_width("framed");
  y2 = cell_height("framed");  /* save size of framed */

  place("framed");

  y0_ = cell_height("clkdly");
  place("wspads");

  y0_ = y2 - cell_height("wnpads") - cell_height("vext");
  place("wnpads");

  x0 = x2;
  y0_ = 0;
  place("espads");

/* dont have these anymore ********************
  x0 = x2 - cell_width("sepads") + cell_width("videosd2pad");
  y0_ = -cell_height("sepads");
  place("sepads");
***********************************************/

  /**x0:=x2; y0:=y2-cell_height('enpads'); **/
  /*** place('enpads');  ***/

  x0 = x2 - cell_width("nepads");
  y0_ = y2;
  place("nepads");

  x0 = cell_width("vext");
  y0_ = y2;
  place("nwpads");

  endef();

  x0=0;
  y0_=0;

  nocompose();
  place("chip");

  shut_down();
  exit(EXIT_SUCCESS);
}

/* End. */

